require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/documents', type: :request do
  # Tools::Document. As you add validations to Tools::Document, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1, name: 'Doc 1', file: doc_ok} }
  let(:invalid_attributes) { {rca_id: rca.id, tool_reference: 1, name: ''} }

  let(:doc_ok) do
    ActiveStorage::Blob.create_and_upload!(
      io: File.open(file_ok, 'rb'),
      filename: 'not_image.pdf',
      content_type: 'file/pdf'
    ).signed_id
  end

  let(:file_ok) { Rails.root.join('spec', 'support', 'assets', 'images', 'not_image.pdf') }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get tools_documents_url

          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          Tools::Document.create! valid_attributes

          get('/tools/documents', params: {rca: rca.id})
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /new' do
      it 'renders a successful response' do
        get new_tools_document_url(tools_document: valid_attributes)
        expect(response).to be_successful
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_document = Tools::Document.create! valid_attributes
        get edit_tools_document_url(tools_document)
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::Document' do
          expect {
            post tools_documents_url, params: { tools_document: valid_attributes }
          }.to change(Tools::Document, :count).by(1)
        end

        it 'redirects to the created tools_document' do
          post tools_documents_url, params: { tools_document: valid_attributes }
          expect(response).to redirect_to(tools_documents_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::Document' do
          expect {
            post tools_documents_url, params: { tools_document: invalid_attributes }
          }.to change(Tools::Document, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_documents_url, params: { tools_document: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'Nouveau nom'} }

        it 'updates the requested tools_document' do
          tools_document = Tools::Document.create! valid_attributes
          patch tools_document_url(tools_document), params: { tools_document: new_attributes }
          tools_document.reload

          expect(tools_document.name).to eq 'Nouveau nom'
        end

        it 'redirects to the tools_documents index page' do
          tools_document = Tools::Document.create! valid_attributes
          patch tools_document_url(tools_document), params: { tools_document: new_attributes }
          tools_document.reload
          expect(response).to redirect_to(tools_documents_url(rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_document = Tools::Document.create! valid_attributes
          patch tools_document_url(tools_document), params: { tools_document: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_document' do
        tools_document = Tools::Document.create! valid_attributes
        expect {
          delete tools_document_url(tools_document)
        }.to change(Tools::Document, :count).by(-1)
      end

      it 'redirects to the tools_documents list' do
        tools_document = Tools::Document.create! valid_attributes
        delete tools_document_url(tools_document)
        expect(response).to redirect_to(tools_documents_url(rca: rca))
      end
    end
  end
end
